/*
*        _____  _        __    __                 __      __
*       |  _  || |  __ _ \ \  / / ___  _ __      /  |    /  |
*       | |_| || | / _` | \ \/ / / _ \| '__|    |_  |   |_  |
*       |  ___|| || (_| |  \  / |  __/| |         | |  _  | |
*       |_|    |_| \__,_|  /_/   \___||_|         |_| |_| |_|
*
* (c) 2004 FreeWare - Humberto Fornazier / Brasil
*             hfornazier@yahoo.com.br
*      http://www.geocities.ws/harbourminas/
*
* Humberto Fornazier - Junho/2004
* hfornazier@yahoo.com.br
*
* Harbour MiniGUI Build 98 (HMG 1.0 RELEASE CANDIDATE XIV) (2004.05.30)
* Copyright 2002 Roberto Lopez <roblez@ciudad.com.ar>
* http://www.geocities.com/harbour_minigui/
*
* Rewrited for OOHG by Miguel A. Jurez A. <migsoft@oohg.org> - April/2022
*
*/

#include "oohg.ch"
#Include "Directry.ch"
#include "hbextcdp.ch"
#include "fileio.ch"
#include "MyPlayer.ch"

/*
*/
Procedure Main()

    Ambiente_Inicial()
    MusicasDisponiveis()
    Definiciones_One()

Return
/*
*/
Procedure Ambiente_Inicial()

    REQUEST HB_CODEPAGE_ESWIN
    HB_CDPSELECT( "ESWIN" )
    hb_setTermCP( "ES850" )

    Cria_Ini_File()

    cDirMusicas := PastaAtualDeMusicas()
    lContinua   := ReproduzirContinuamente()
    lSorteia    := SorteiaMusicas()

    cSkin       := Skins()

    If ! File( cSkin )
        cSkin := "MyPlayer"
    EnDif

Return Nil
/*
 * - Esta Funo verifica as Msicas disponveis na pasta de Msica Definida pelo usurio
 * - Verifica Musicas que contenham as Palavras definidas em MyPlayer.INI
 * -
 */
Function MusicasDisponiveis()
    Local aFiles    := Directory( cDirMusicas+"*.*" )  //mp3" )
    Local i := 0, j := 0
    Local aPalavras := Palavras()

    aMusicas := {}

        For i := 1 To Len( aFiles )
            If Len( aPalavras ) == 0
               If Upper( Right( Alltrim( aFiles[ i ][ 1 ] ),3 ) ) = "MP3"
                  Aadd( aMusicas , Alltrim( aFiles[ i ][ 1 ] ) )
                  lPlaylist := .F.
               ElseIF Upper( Right( Alltrim( aFiles[ i ][ 1 ] ),3 ) ) = "M3U"
                  Aadd( aMusicas , Alltrim( aFiles[ i ][ 1 ] ) )
                  lPlaylist := .T.
               ElseIF Upper( Right( Alltrim( aFiles[ i ][ 1 ] ),4 ) ) = "M3U8"
                  Aadd( aMusicas , Alltrim( aFiles[ i ][ 1 ] ) )
                  lPlaylist := .T.
               Endif
            Else
                For j := 1 To Len( aPalavras )
                    If Upper( aPalavras[ j ] ) $ Upper( aFiles[ i ][ 1 ] )
                       If Upper( Right( Alltrim( aFiles[ i ][ 1 ] ),3 ) ) = "MP3"
                          Aadd( aMusicas , Alltrim( aFiles[ i ][ 1 ] ) )
                          lPlaylist := .F.
                          EXIT
                       ElseIF Upper( Right( Alltrim( aFiles[ i ][ 1 ] ),3 ) ) = "M3U"
                          Aadd( aMusicas , Alltrim( aFiles[ i ][ 1 ] ) )
                          lPlaylist := .T.
                          EXIT
                       ElseIF Upper( Right( Alltrim( aFiles[ i ][ 1 ] ),4 ) ) = "M3U8"
                          Aadd( aMusicas , Alltrim( aFiles[ i ][ 1 ] ) )
                          lPlaylist := .T.
                          EXIT
                       Endif
                    Else
                        Loop
                    EnDif
                Next
            EndIf
        Next

        ASort( aMusicas )

Return Nil
/*
*/
*------------------------------------------------------------*
FUNCTION Slider1_Change()
*------------------------------------------------------------*
    LOCAL nValue := Form_Player.Slider_1.VALUE
    SET PLAYER Play_1 OF Form_Player VOLUME nValue * 100
RETURN NIL
/*
*/
*------------------------------------------------------------*
FUNCTION Slider2_Change()
*------------------------------------------------------------*
    LOCAL nValue := Form_Player.Slider_2.VALUE
    Form_Player.Slider_2.VALUE := ( Int( Form_Player.Play_1.Position / nLenght  * 100 ) )
RETURN NIL
*------------------------------------------------------------*
FUNCTION IsMP3()
*------------------------------------------------------------*
    If lPlaylist
       lResp := .F.
    Else
       lResp := .T.
    Endif
RETURN( lResp )
/*
*/
Procedure ExecutarMusica( cMusica )

    If !Empty( cMusica ) .or. File( cMusica )
        If IsControlDefined( Timer_Abertura, Form_Player )
            Form_Player.Timer_Abertura.Release
        Endif

        IF Upper( Right( Alltrim( cMusica ), 3 ) ) = "M3U" .OR. Upper( Right( Alltrim( cMusica ), 4 ) ) = "M3U8"
           lPlaylist                       := .T.
           AchoiceChannel( cMusica )
        Else
           cFile                           := cMusica
           Form_Player.Play_1.Open( cFile )

           If ! IsControlDefined( Timer_1, Form_Player )
              DEFINE TIMER Timer_1 INTERVAL 200 ACTION ChekaTerminoDaMusicaExecutada() OF Form_Player
           EnDif

           cNomeMusicaAtual                := NomeDoArquivo( cFile )
           nLenght                         := Form_Player.Play_1.Length
           Form_Player.Img_Leds1.Picture   := "Led1On"

           Form_Player.Play_1.Play()

           lPlayPause                      := .F.
           Form_Player.Title               := cNomeMusicaAtual
           Form_Player.LbTempoTotal.Value  := TempoTotal( nLenght )
           nCtEfeito                       := 0
           cDescEfeito                     := ""

           CambiaTrack()

        Endif
    Else
        MsgInfo( "Error File is not Found: "+cMusica )
    EnDif

Return
/*
 * El Temporizador configurado en el Programa (Timer_1) comprueba en esta funcin si la cancin ha finalizado.
 * La variable nLenght tiene el tamao de la cancin y Form_Player.Play_1.Position proporciona la
 * posicin actual de la cancin que se est reproduciendo.
 * Cuando la Posicin Escuchada es mayor o igual al tamao total de la cancin:
 * - El tamao de la cancin se restablece
 * - El lanzamiento se realiza en el temporizador (que se recrear cuando se reproduzca una nueva cancin)
 * - Si la Variable lContinua es .T., el programa seleccionar una nueva cancin, si
 *   de lo contrario marque Variable lPlayPause
 */
Procedure ChekaTerminoDaMusicaExecutada()

  If IsMP3()

    If Form_Player.Play_1.Position >= nLenght
        nLenght := 0
        If IsControlDefined( Timer_1, Form_Player )
            Form_Player.Timer_1.Release
        Endif
        If lContinua
            nProxima = nProxima + 1
            If Len( aMusicas ) > 0
                If lSorteia
                    nProxima := Random( Len( aMusicas ) )
                    nProxima := Iif( nProxima == 0 , 1 , nProxima )
                EnDif
                If nProxima > Len( aMusicas ) .or. nProxima < 1
                    nProxima := 1
                EnDif
                ExecutarMusica( cDirMusicas + aMusicas[ nProxima ] )
            Else
                lPlayPause := .T.
            EnDif
        Else
            lPlayPause := .T.
        EnDif
        If lPlayPause
            If IsControlDefined( Timer_1, Form_Player )
                Form_Player.Timer_1.Release
            Endif
        EnDif
    EndIf

    Slider2_Change()
    Slider1_Change()

    If ! lPlayPause
        Form_Player.LbTempoReproducao.Value := TempoTotal( nLenght - Form_Player.Play_1.Position )
        EfeitoLabel2()
        If lDesliga
            Form_Player.LbClockTermino.Value := "Clock: "+Right( Elaptime( cDesligarEm , Time() ) , 5 ) + " in " + Alltrim( cMinutos )
            If Right( Elaptime( cDesligarEm , Time() ) , 5 ) >= Alltrim( cMinutos )
                If IsControlDefined( Play_1, Form_Player )
                    Form_Player.Play_1.Stop
                    Form_Player.Play_1.Release
                EnDif
                Form_Player.Release
            EnDif
        EnDif
    EnDif

  Endif

  DO EVENTS

Return
/*
*/
Procedure CambiaTrack
    Form_Player.LbMusicaAtual.Value := AllTrim(Str( nProxima ))+"/"+AllTrim(Str(Len( aMusicas )))
Return
/*
*/
Procedure MyPlay()
  If IsMP3()
    If Len( aMusicas ) > 0
          If lPlayPause
             Form_Player.Play_1.Resume()
             Form_Player.Img_Leds1.Picture := "Led1On"
          Else
             SET PLAYER Play_1 Of Form_Player POSITION HOME
             Form_Player.Play_1.Play()
             nLenght := Form_Player.Play_1.Length
             ExecutarMusica( cDirMusicas+aMusicas[ nProxima ] )
             ChekaTerminoDaMusicaExecutada()
          Endif
          CambiaTrack()
          lPlayPause:= .F.
    Endif
  Endif
Return
/*
*/
Procedure MPProximaMusica()
  If IsMP3()
    If Len( aMusicas ) > 0
        SET PLAYER Play_1 Of Form_Player POSITION END
        lPlayPause:= .F.
        nProxima := nProxima + 1
        If nProxima >= Len( aMusicas )
           nProxima := Len( aMusicas )
        Endif
        ExecutarMusica( cDirMusicas+aMusicas[ nProxima ] )
        ChekaTerminoDaMusicaExecutada()
        CambiaTrack()
    Endif
  Endif
Return nil
/*
*/
Procedure MPMusicaAnterior()
  If IsMP3()
    If Len( aMusicas ) > 0
        SET PLAYER Play_1 Of Form_Player POSITION END
        lPlayPause:= .F.
        nProxima  := nProxima - 1
        If nProxima <= 0
           nProxima := 1
        Endif
        ExecutarMusica( cDirMusicas+aMusicas[ nProxima ] )
        ChekaTerminoDaMusicaExecutada()
        CambiaTrack()
    Endif
  Endif
Return nil
/*
*/
Procedure MPMusicaInicio()
  If IsMP3()
    If Len( aMusicas ) > 0
        SET PLAYER Play_1 Of Form_Player POSITION HOME
        lPlayPause:= .F.
        nProxima  := 1
        ExecutarMusica( cDirMusicas+aMusicas[ nProxima ] )
        ChekaTerminoDaMusicaExecutada()
        CambiaTrack()
    Endif
  Endif
Return Nil
/*
*/
Procedure MPMusicaFinal()
  If IsMP3()
    If Len( aMusicas ) > 0

        SET PLAYER Play_1 Of Form_Player POSITION END
        lPlayPause:= .F.
        nProxima  := Len( aMusicas )
        ExecutarMusica( cDirMusicas+aMusicas[ nProxima ] )
        ChekaTerminoDaMusicaExecutada()
        CambiaTrack()
    Endif
  Endif
Return Nil
/*
*/
Procedure PararReproducao()
  If IsMP3()
    Form_Player.Play_1.Stop
    Form_Player.Img_Leds1.Picture       := "Led1Off"
    If IsControlDefined( Timer_1, Form_Player )
        Form_Player.Timer_1.Release
    EnDif
    ResetCount()
    nProxima                            := 1
    If !IsControlDefined( Timer_Abertura, Form_Player )
        DEFINE TIMER Timer_Abertura INTERVAL 100 ACTION Efeito_Abertura() OF Form_Player
    Endif
    SET PLAYER Play_1 Of Form_Player POSITION HOME
    lPlayPause                          := .F.
    Form_Player.Slider_2.VALUE          := 0
  Endif
Return Nil
/*
*/
Procedure MyPause()
  If IsMP3()
    If ! Empty( cFile ) .OR. File ( cFile )
       If Form_Player.Play_1.Position > 0
        If ! lPlayPause
            Form_Player.Img_Leds1.Picture   := "Led1Off"
            Form_Player.LbMusicaAtual.Value := "Pause "
            Form_Player.Play_1.Pause()
            lPlayPause := .T.
        Else
            Form_Player.Img_Leds1.Picture := "Led1On"
            CambiaTrack()
            Form_Player.Play_1.Resume()
            lPlayPause := .F.
        EndIf
       Endif
    Endif
  Endif
Return Nil
/*
*/
Function AchoiceMusicas()
    Local aItens  := {}
    Local nRow    := oWin:Height() + oWin:Row()
    Local nCol    := oWin:Col()

    aItens        := aMusicas
    ASort( aItens )

    DEFINE WINDOW Form_2                 ;  //212
        AT nRow,nCol                     ;  //192
        WIDTH 492 HEIGHT 280             ;
        TITLE 'Select File:'             ;
        ICON 'Musicas2'                  ;
        MODAL                            ;
        NOSIZE

        @ 190,0 Image BackGr             ;
            PICTURE cSkin                ;
            WIDTH 490                    ;
            HEIGHT 100

        @ 0,0 LISTBOX List_1             ;
            WIDTH  490                   ;
            HEIGHT 200                   ;
            ITEMS aItens                 ;
            VALUE 1                      ;
            FONT "Ms Sans Serif" SIZE 09 ;
            ON DBLCLICK  DesdeList( aItens )

        @  210,10 Label LbPastaAtual     ;
            Width  330                   ;
            Height  20                   ;
            Value 'Folder: '+cDirMusicas ;
            Font 'Arial' SIZE 07         ;
            FontColor WHITE              ;
            AUTOSIZE TRANSPARENT

        @ 228,10 Button Bt_Folder        ;
            Picture 'Folder'             ;
            Action NovaPastaDeMusicas()  ;
            Width   22                   ;
            Height  22                   ;
            Flat                         ;
            ToolTip "Select Folder:"

        @ 228,36 Button Bt_Close         ;
            Picture 'Close'              ;
            Action Form_2.Release        ;
            Width   22                   ;
            Height  22                   ;
            Flat                         ;
            ToolTip "Close..."

    END WINDOW

    Form_2.Activate

Return Nil
/*
*/
Procedure DesdeList( aOrd )

    nProxima := Form_2.List_1.Value
    ExecutarMusica( cDirMusicas+aOrd[ Form_2.List_1.Value ] )

Return
/*
*/
Function AchoiceChannel( cMusica )
    Local aItens  := {}, aNome := {}
    Local nRow    := oWin:Height() + oWin:Row()
    Local nCol    := oWin:Col()

    ResetCount()

    aOrd          := {}
    aM3U          := M3U2Arr( cMusica )

    For n := 1 to Len( aM3U )
        Aadd( aItens, aM3U[n][3] )
        Aadd( aOrd, aM3U[n][4] )
        Aadd( aNome, NomeDoArquivo(aM3U[n][4] ) )
    Next

    If Upper( Right( Alltrim( aM3U[1][4] ), 4 ) ) = "MP3"
       cDirMP3 := cFilePath(aM3U[1][4])
       ACopy( aOrd, aItens )
    Endif

    DEFINE WINDOW Form_3                 ;
        AT nRow,nCol                     ;   //260,192
        WIDTH 492 HEIGHT 280             ;
        TITLE 'Select Channel:'          ;
        ICON 'Musicas2'                  ;
        MODAL                            ;
        NOSIZE

        @ 190,0 Image BackGr             ;
            PICTURE cSkin                ;
            WIDTH  490                   ;
            HEIGHT 100

        @ 0,0 LISTBOX List_1             ;
            WIDTH  490                   ;
            HEIGHT 200                   ;
            ITEMS aItens                 ;
            VALUE 1                      ;
            FONT "Ms Sans Serif" SIZE 09 ;
            ON DBLCLICK  DesdeList2( aOrd )

        @ 228,36 Button Bt_Close         ;
            Picture 'Close'              ;
            Action Form_3.Release        ;
            Width   22                   ;
            Height  22                   ;
            Flat                         ;
            ToolTip "Close..."

    END WINDOW

    Form_3.Activate

Return
/*
*/
Procedure DesdeList2()

    nProxima := Form_3.List_1.Value
    cDos     := NomeDoArquivo( aOrd[ Form_3.List_1.Value ] )
    cDos     := StrTran(cDos,CHR(13),"")

    ParaPlay()

    If Upper( Right( cDos, 3 ) ) == "MP3"
       cFileMP3 := '"'+cDirMP3+'"'
       //EXECUTE FILE "wmplayer.exe" PARAMETERS "/prefetch:1 "+cFileMP3
       EXECUTE FILE "vlc.exe" PARAMETERS '"'+cDos+'"'
    Else
       cDos     := aOrd[ Form_3.List_1.Value ]
       cDos     := StrTran(cDos,CHR(13),"")
       //EXECUTE FILE "wmplayer.exe" PARAMETERS cDos
       EXECUTE FILE "vlc.exe" PARAMETERS '"'+cDos+'"'
    Endif

Return
/*
*/
Procedure ParaPlay()
    If Form_Player.Play_1.Position > 0
       Form_Player.Img_Leds1.Picture       := "Led1Off"
       ResetCount()
       Form_Player.Play_1.Stop
       SET PLAYER Play_1 Of Form_Player POSITION HOME
       Form_Player.Slider_2.Value          := 0
       Form_Player.Slider_2.Redraw()
       lPlayPause                          := .F.
    Endif
Return
/*
*/
Procedure ResetCount()
       Form_Player.LbTempoReproducao.Value := '00:00'
       Form_Player.LbTempoTotal.Value      := '00:00'
       Form_Player.LbMusicaAtual.Value     := '0/0'
Return
/*
*/
Procedure NovaPastaDeMusicas()
    Local cFolder := GetFolder()
    Local cOldDir := cDirMusicas

    If ! Empty( cFolder )
        BEGIN INI FILE cDirExe+"MyPlayer.ini"
            SET SECTION "SONGS" ENTRY "Music Folder"  To AllTrim( cFolder )+"\"
        END INI
    EnDif

    cDirMusicas := PastaAtualDeMusicas()

    If Empty( cDirMusicas ) .Or. cDirMusicas == cOldDir
        Return Nil
    EnDif

    MusicasDisponiveis()

    If IsMP3()

       If Len( aMusicas ) > 0
          ExecutarMusica( cDirMusicas+aMusicas[ 1 ] )
       EnDif

    Endif

    Form_2.Release

    AchoiceMusicas()

Return Nil
/*
 * Cria o Arquivo MyPlayer.INI
 */
Function Cria_Ini_File()
    If ! File( cDirExe+"MyPlayer.INI")
        BEGIN INI FILE cDirExe+"MyPlayer.ini"
            SET SECTION "SONGS"       ENTRY "Music Folder"                To cDirExe+"Songs\"
            SET SECTION "PREFERENCES" ENTRY "Play Continuously"           To "YES"
            SET SECTION "PREFERENCES" ENTRY "Songs That Contain the Word" To ""
            SET SECTION "PREFERENCES" ENTRY "Raffle Songs"                To "NO"
            SET SECTION "PREFERENCES" ENTRY "Skin"                        To "MyPlayer.Gif"
        END INI
    EndIf
Return Nil
/*
 *   Ao Sair do Programa Passa por esta Rotina:
 * - Elimina o Controle Player
 * - Atualiza variveis no Arquivo Player.INI
 */
Procedure PlayerSaidaDoPrograma()
    If IsControlDefined( Player, Form_Player )
        Form_Player.Play_1.Stop
        Form_Player.Play_1.Release
    EnDif
          *** Atualiza Arquivo MyPlayer.INI
    BEGIN INI FILE cDirExe+"MyPlayer.ini"
        SET SECTION "SONGS"       ENTRY      "Music Folder"        To cDirMusicas
        SET SECTION "PREFERENCES" ENTRY      "Play Continuously"   To Iif( lContinua , "YES" , "NO" )
        SET SECTION "PREFERENCES" ENTRY      "Raffle Songs"        To Iif( lSorteia  , "YES" , "NO" )
        SET SECTION "PREFERENCES" ENTRY      "Skin"                To cSkin
    END INI
Return Nil
/*
 * Lee Arquivo MyPlayer.Ini e Retorna a Pasta de Musicas
 */
Function PastaAtualdeMusicas()
    Local cValue := ""
    BEGIN INI FILE cDirExe+"MyPlayer.ini"
        GET cValue SECTION "SONGS" ENTRY "Music Folder"
    END INI
Return Upper( cValue )
/*
 * Lee Arquivo MyPlayer.Ini e Retorna Palavras Selecionadas
 * as palavras devem estar separadas com ";" Ponto e Vrgula
 * Exemplo: Viver;Elvis Plesley;Beatles;corao
 */
Function Palavras()
    Local aValue := ""
    Local cValue := ""
    BEGIN INI FILE cDirExe+"MyPlayer.ini"
        GET cValue SECTION "PREFERENCES" ENTRY "Songs That Contain the Word"
    END INI
    aValue := ListAsArray( Upper( cValue ) , ";" )
Return aValue
/*
 * Lee Arquivo MyPlayer.Ini e Retorna .T. se o Programa vai Sortear Musicas para a execuo
 */
Function SorteiaMusicas()
    Local cvalue := ""
    BEGIN INI FILE cDirExe+"MyPlayer.ini"
        GET cValue SECTION "PREFERENCES" ENTRY "Raffle Songs"
    END INI
Return( Iif( AllTrim( cValue ) == "YES" , .T. , .F. ) )
/*
 * Lee Arquivo MyPlayer.Ini e Retorna .T. se o Programa vai Reproduzir Musicas continuamente
 */
Function ReproduzirContinuamente()
    Local cvalue := ""
    BEGIN INI FILE cDirExe+"MyPlayer.ini"
        GET cValue SECTION "PREFERENCES" ENTRY "Play Continuously"
    END INI
Return( Iif( AllTrim( cValue ) == "YES" , .T. , .F. ) )
/*
 * Lee Arquivo MyPlayer.Ini e Retorna imagem para Skin
 */
Function Skins()
    Local cvalue := ""
    BEGIN INI FILE cDirExe+"MyPlayer.ini"
        GET cValue SECTION "PREFERENCES" ENTRY "Skin"
    END INI
Return( AllTrim( cValue ) )
/*
*/
Function ListAsArray( cList, cDelimiter )
    Local nPos
    Local aList := {}
    If ! Empty( cList )
        Do While ( nPos := AT( cDelimiter, cList )) != 0
            Aadd( aList, Substr( cList, 1, nPos - 1 ))
            cList := Substr( cList, nPos + 1 )
        EndDo
        Aadd( aList, cList )
    EndIf
Return( aList )
/*
*/
Function TempoTotal( nTam )
    Local cRet := AllTrim( Str( Int( ( nTam / 60 ) / 1000 ) ) ) + ":" + AllTrim( Str( Int( ((( nTam / 60 ) / 1000 ) - Int( ( nTam / 60 ) / 1000 ) ) * 60 ) ) )
    If Int( Val( cRet ) ) < 10
        cRet := "0"+cRet
    EnDif
    If Left( Right( cRet ,2 ) , 1 ) == ":"
        cRet := cRet+"0"
    EnDif
Return cRet
/*
*/
Function NomeDoArquivo( cArq )
    If Upper( Right( cArq, 3) ) = "MP3"
        cArq := Right( cArq , Len( cArq ) - ( Rat( "\" , cArq ) ) )
        cArq := StrTran( cArq , ".MP3", "" )
        cArq := StrTran( cArq , ".mp3", "" )
    ElseIf Upper( Right( cArq, 3) ) = "M3U"
        cArq := Right( cArq , Len( cArq ) - ( Rat( "\" , cArq ) ) )
        cArq := StrTran( cArq , ".M3U", "" )
        cArq := StrTran( cArq , ".m3u", "" )
    ElseIf Upper( Right( cArq, 4) ) = "M3U8"
        cArq := Right( cArq , Len( cArq ) - ( Rat( "\" , cArq ) ) )
        cArq := StrTran( cArq , ".M3U8", "" )
        cArq := StrTran( cArq , ".m3u8", "" )
    Endif
Return( cArq )
/*
    Para Este efeito o Label deve ser declarado como CenterAlign
*/
Procedure EfeitoLabel2()
    Local cTxt := AllTrim( cNomeMusicaAtual )
    Local nTam := Len( cTxt )
    nCtEfeito += 1
    If nCtEfeito > nTam
        If nCtEfeito > 50
            nCtEfeito := 0
            cDescEfeito := ""
        EnDif
    Else
        cDescEfeito += Substr( cTxt ,  nCtEfeito , 1 )
    EnDif
    Form_Player.Title := cDescEfeito
Return Nil
/*
*/
Procedure Efeito_Abertura()
    Local cTxt    := ""
    Local nTam    := 0
    Local iTime   := Seconds()
    Local aMensag := { "MyPlayer - Version 1.1"                 , ;
                       "By Humberto Fornazier/Brasil"           , ;
                       "http://www.geocities.ws/harbourminas/ " , ;
                       "Harbour - Harbour Project"              , ;
                       "https://harbour.github.io/"             , ;
                       "HMG - Roberto Lopez - Argentina"        , ;
                       "http://harbourminigui.blogspot.com"     , ;
                       "OOHG - https://oohg.github.io/"           }

    cTxt := aMensag[ nCt ]
    nTam := Len( cTxt )

    nCtEfeito += 1

    If  nCtEfeito > nTam
        nCtEfeito   := 0
        cDescEfeito := ""
        nCt++
        nCt  := Iif( nCt > 8 , 1 , nCt )
    Else
        cDescEfeito += Substr( cTxt ,  nCtEfeito , 1 )
    EnDif

    Form_Player.Title := cDescEfeito

Return Nil
/*
*/
Procedure Bt_Salvar_Execute()
    Local cPalavras := AlLTrim( Form_Config.Palavras.Value )
    BEGIN INI FILE cDirExe+"MyPlayer.ini"
        SET SECTION "PREFERENCES" ENTRY "Play Continuously"           To Iif( Form_Config.Reproduzir.Value , "YES" , "NO" )
        SET SECTION "PREFERENCES" ENTRY "Songs That Contain the Word" To cPalavras
        SET SECTION "PREFERENCES" ENTRY "Raffle Songs"                To Iif( Form_Config.Sortear.Value , "YES" , "NO" )
    END INI
    lContinua := Form_Config.Reproduzir.Value
    lSorteia  := Form_Config.Sortear.Value
    Form_Config.Release
Return Nil
*------------------------------------------------------------*
FUNCTION m3u2Arr ( cFileM3U )
*------------------------------------------------------------*
    LOCAL cMemo, nLines, n, nMax, nPosi, cLine
    LOCAL aOne := {}, aLines := {}
    LOCAL cTVname, cTVlogo, cTVgroup, cTVurl
    LOCAL lDone := .F., lSucces := .F.

  BEGIN SEQUENCE WITH {| oError | Break( oError ) }

    cMemo  := Hb_MemoRead( cFileM3U )
    cMemo  := StrTran( cMemo, CHR(10), CHR(13)+CHR(10) )
    aLines := hb_ATokens( cMemo, CHR(10) )
    nMax   := Len( aLines )

    FOR n  := 1 TO nMax

        cLine := MemoLine( cMemo, 15000, n, 2 , .T. )

        IF Empty( cLine )  .OR.  "#EXTM3U" $ Upper(cLine)
            LOOP
        ENDIF

        IF "#EXTINF" $ Upper(cLine)

            cTVname  := ""
            cTVlogo  := ""
            cTVgroup := ""
            cTVurl   := ""
            lDone    := .F.

            DO WHILE lDone = .F.

                IF AT( "tvg-logo=", cLine ) > 0
                    nPosi := AT( "tvg-logo=", cLine )
                    IF nPosi > 0
                        cTVlogo := SUBSTR( cLine, nPosi + 10 )
                        nPos2   := ATI( '"', cTVlogo )
                        cTVlogo := Left( SUBSTR( cTVlogo, 1, nPos2 - 1 ), 300 )
                    ENDIF
                ENDIF

                IF AT( "group-title=", cLine ) > 0
                    nPosi := AT( "group-title=", cLine )
                    IF nPosi > 0
                        cTVgroup := SUBSTR( cLine, nPosi + 13 )
                        nPos2    := ATI( '"', cTVgroup )
                        cTVgroup := Left( SUBSTR( cTVgroup, 1, nPos2 - 1 ), 80)
                    ENDIF
                ENDIF

                IF AT( ',', cLine ) > 0
                    nPosi  := AT( ',', cLine )
                    IF nPosi > 0
                        cTVname := SUBSTR( cLine, nPosi + 1 )
                        nPos2   := ATI( ',', cTVname )
                        IF nPos2 > 0
                            cTVname := SUBSTR( cTVname, nPos2 +1 )
                        Endif
                    ENDIF
                ENDIF

                lDone := .T.

            ENDDO

        ELSEIF "HTTP" $ Upper(cLine) .OR. "PLUGIN://" $ Upper(cLine) .OR. ":\" $ Upper(cLine)

            IF AT( "http://", cLine ) > 0
                nPosi  := AT( "http://", cLine )
                IF nPosi > 0
                    cTVurl := Left( SUBSTR( cLine, nPosi ), 500)
                ENDIF
            ENDIF

            If Empty( cTVurl )

                IF AT( "https://", cLine ) > 0
                    nPosi  := AT( "https://", cLine )
                    IF nPosi > 0
                        cTVurl := Left( SUBSTR( cLine, nPosi ), 500)
                    ENDIF
                ENDIF

            Endif

            IF AT( "plugin://", cLine ) > 0
                nPosi  := AT( "plugin://", cLine )
                IF nPosi > 0
                    cTVurl := Left( SUBSTR( cLine, nPosi ), 500)
                ENDIF
            ENDIF

            IF AT( ":\", cLine ) > 0
                nPosi  := AT( ":\", cLine )
                IF nPosi > 0
                    cTVurl := Left( SUBSTR( cLine, nPosi - 1 ), 500)
                ENDIF
            ENDIF

            AAdd( aOne, {AllTrim( cTVlogo ), AllTrim( cTVgroup ), AllTrim( cTVname ), AllTrim( cTVurl )} )

        ENDIF

        DO EVENTS

    NEXT

    lSucces := .T.

  RECOVER USING oError
    AutoMsgInfo( oError:Operation+CRLF+oError:Description, "Error !!!" )
    lSucces := .F.

  END

/*
  AutoMsgInfo( Hb_ValtoExp( aOne) )
*/

RETURN( aOne )

*---------------------------------------------------------------------*
Function cFilePath( cPathMask )
*---------------------------------------------------------------------*
   local n := RAt( "\", cPathMask ), cDisk

Return If( n > 0, Upper( Left( cPathMask, n ) ),;
       ( cDisk := cFileDisc( cPathMask ) ) + If( ! Empty( cDisk ), "\", "" ) )
*---------------------------------------------------------------------*
Function cFileDisc( cPathMask )
*---------------------------------------------------------------------*
Return If( At( ":", cPathMask ) == 2, Upper( Left( cPathMask, 2 ) ), "" )
*---------------------------------------------------------------------*
Procedure Definiciones_One()
*---------------------------------------------------------------------*
    Local nCol := 10, nColp := (GetDeskTopWidth() + 8)/2

    Define Window Form_Player OBJ oWin        ;
        At 100, nColp - 160 - 80              ;
        Width  492                            ;
        Height 160                            ;
        Title  'MyPlayer - Status'            ;
        ICON "MUSICAS2"                       ;
        MAIN                                  ;
        NOSIZE                                ;
        NOMAXIMIZE                            ;
        TOPMOST                               ;
        ON RELEASE PlayerSaidaDoPrograma()

        @ 0,0 Image ImageBackGr               ;
            PICTURE cSkin                     ;
            WIDTH 486 HEIGHT 131

        @ 000,008 Frame Frame1                ;
            Caption ''                        ;
            Width  470                        ;
            Height  49

        @ 050,008 Frame Frame2                ;
            Caption ''                        ;
            Width  470                        ;
            Height  39

        @ 019,012 Label LbMusicaAtual2          ;
            Width   45                          ;
            Height  20                          ;
            Value 'Song: '                      ;
            Font 'MS Sans Serif' SIZE 12        ;
            FontColor WHITE TRANSPARENT

        @ 018,060 Label LbMusicaAtual           ;
            Width   80                          ;
            Height  20                          ;
            Value '0/0'                         ;
            Font 'MS Sans Serif' SIZE 14        ;
            FontColor WHITE TRANSPARENT BOLD

        @ 064,013 Label LbReproduzindo         ;
            Width   98                         ;
            Height  16                         ;
            Value 'Countdown: '                ;
            Font 'MS Sans Serif' SIZE 10       ;
            FontColor WHITE TRANSPARENT

        @ 060,105 Label LbTempoReproducao       ;
            Width  50                           ;
            Height 24                           ;
            Value '00:00'                       ;
            Font 'MS Sans Serif' SIZE 14 Bold   ;
            FontColor WHITE TRANSPARENT

        @ 064,205 Label LbClockTermino          ;
            Width   80                          ;
            Height  16                          ;
            Value 'Clock 00:00'                 ;
            Font 'MS Sans Serif' SIZE 10        ;
            FontColor WHITE TRANSPARENT

        @ 063,320 Label LbTotal                ;
            Width   90                         ;
            Height  16                         ;
            Value 'Total Time:'                ;
            Font 'MS Sans Serif' SIZE 10       ;
            FontColor WHITE TRANSPARENT

        @ 059,411 Label LbTempoTotal           ;
            Width  50                          ;
            Height 24                          ;
            Value '00:00'                      ;
            Font  'MS Sans Serif' SIZE 14 Bold ;
            FontColor WHITE TRANSPARENT

        @ 096,nCol Button Bt_Stop              ;
            Picture 'Stop'                     ;
            Action  PararReproducao()          ;
            Width  22                          ;
            Height 22                          ;
            Flat                               ;
            ToolTip "Stop..."

        @ 096,nCol+=26 Button Bt_Play                  ;
            Picture 'Play'                             ;
            Action   MyPlay()                          ;
            Width  22                                  ;
            Height 22                                  ;
            Flat                                       ;
            ToolTip "Play..."

        @ 096,nCol+=26 Button Bt_Pause                 ;
            Picture 'Pause'                            ;
            Action MyPause()                           ;
            Width  22                                  ;
            Height 22                                  ;
            Flat                                       ;
            ToolTip "Pause..."

        @ 096,nCol+=26 Button Bt_Next                     ;
            Picture 'Next'                                ;
            Action  MPProximaMusica()                     ;
            Width  22                                     ;
            Height 22                                     ;
            Flat                                          ;
            ToolTip "Next..."

        @ 096,nCol+=26 Button Bt_Back                      ;
            Picture 'Back'                                 ;
            Action  MPMusicaAnterior()                     ;
            Width  22                                      ;
            Height 22                                      ;
            Flat                                           ;
            ToolTip "Back..."

        @ 096,nCol+=26 Button Bt_Home          ;
            Picture 'Home'                     ;
            Action  MPMUsicaInicio()           ;
            Width  22                          ;
            Height 22                          ;
            Flat                               ;
            ToolTip "Home..."

        @ 096,nCol+=26 Button Bt_Last          ;
            Picture 'Last'                     ;
            Action  MPMUsicaFinal()            ;
            Width  22                          ;
            Height 22                          ;
            Flat                               ;
            ToolTip "Last..."

        nCol := 322

        @ 096,nCol Button Bt_Folder             ;
            Picture 'Folder'                    ;
            Action  AchoiceMusicas()            ;
            Width   22                          ;
            Height  22                          ;
            Flat;
            ToolTip "Select Folder: "

        @ 096,nCol+=26 Button Bt_Clock          ;
            Picture 'Clock'                     ;
            Action  MPAlarme()                  ;
            Width  22                           ;
            Height 22                           ;
            Flat                                ;
            ToolTip "Turn Off Player"

        @ 096,nCol+=26 Button Bt_Skins          ;
            Picture 'Preview'                   ;
            Action   SkinsDisponiveis()         ;
            Width  22                           ;
            Height 22                           ;
            Flat                                ;
            ToolTip "Change Skin"

        @ 096,nCol+=26 Button Bt_Config         ;
            Picture 'Config'                    ;
            Action  Config()                    ;
            Width  22                           ;
            Height 22                           ;
            Flat                                ;
            ToolTip "Config"

        @ 096,nCol+=26 Button Bt_Close          ;
            Picture 'Close'                     ;
            Action Form_Player.Release          ;
            Width  22                           ;
            Height 22                           ;
            Flat                                ;
            ToolTip "Close Player"

        @ 096,nCol+=26 Button Bt_Info           ;
            Picture 'Info'                      ;
            Action  MsgSobre()                  ;
            Width  22                           ;
            Height 22                           ;
            Flat                                ;
            ToolTip "About..."

        @ 095,205 SLIDER Slider_1               ;
            RANGE 0, 10                         ;
            WIDTH 100                           ;
            HEIGHT 24                           ;
            VALUE  5                            ;
            ON CHANGE  Slider1_Change()

        @ 017,150 SLIDER Slider_2               ;
            RANGE 0, 100                        ;
            WIDTH 320                           ;
            HEIGHT 24                           ;
            VALUE  0                            ;
            NOTICKS                             ;
            ON CHANGE  Slider2_Change()

        @ 50,460 Image Img_Leds1                ;
            PICTURE "Led1off"                   ;
            WIDTH 14 HEIGHT 7                   ;
            ACTION PararReproducao()

        @ 00,02 PLAYER Play_1                   ;
            WIDTH 05                            ;
            HEIGHT 05 FILE ""                   ;
            NOMENU NOOPEN                       ;
            SHOWPOSITION

        DEFINE TIMER Timer_Abertura INTERVAL 100 ACTION Efeito_Abertura() OF Form_Player

    End Window

    ON KEY F3 OF Form_Player ACTION  AutoMsgInfo( Hb_ValtoExp( M3u2Arr("t2.m3u" ) ) )
    ON KEY F4 OF Form_Player ACTION  AutoMsgInfo( Hb_ValtoExp( aMusicas ) )
    ON KEY F5 OF Form_Player ACTION  AutoMsgInfo( Hb_ValtoExp( aMusicas[1] ) )

    ON KEY F6 OF Form_Player ACTION  AutoMsgInfo( cDirMusicas+aMusicas[ 1 ] )
    ON KEY F7 OF Form_Player ACTION  AutoMsgInfo( Right( cDirMusicas+aMusicas[ 1 ], 3 ) )
    ON KEY F8 OF Form_Player ACTION  AutoMsgInfo( Hb_ValtoExp( aOrd ) )

    Form_Player.LbMusicaAtual.SetFocus
    Form_Player.Activate

Return
/*
 * Clock - Habilita Minutos para desligar o Player Automaticamente
 */
Procedure MPAlarme()
    Local nRow    := oWin:Height() + oWin:Row()
    Local nCol    := oWin:Col()

    Define Window Form_Alarme                ;
        At nRow,nCol + 138                   ; //260,330
        Width  217                           ;
        Height  99                           ;
        Title  'Turn Off MyPlayer'           ;
        Icon "Musicas2"                      ;
        Modal                                ;
        NoSize

        @ -10,-10 Image ImageBackGr          ;
            PICTURE cSkin                    ;
            WIDTH 320 HEIGHT 100

        @ 0,  0 Frame GroupBox1          ;
            Caption  ''                  ;
            Width  208                   ;
            Height  41

        @  15, 11 Label Label1           ;
            Width   73                   ;
            Height  16                   ;
            Value 'Turn Off in'          ;
            Font 'MS Sans Serif' SIZE 10 ;
            FontColor WHITE Transparent

        @  15,147 Label Label2           ;
            Width   46                   ;
            Height  16                   ;
            Value 'minutes'              ;
            Font 'MS Sans Serif' SIZE 10 ;
            FontColor WHITE Transparent

        @  13, 92 TextBox TxtMinutos     ;
            Width   49                   ;
            Value '00:00'                ;
            InputMask "99:99"

        @  48,  8 Button BtOk            ;
            Caption '&Ok'                ;
            Action ( lDesliga := .T. , Form_Player.LbClockTermino.Visible := .T. , ;
            cDesligarEm := Time(), cMinutos := AllTrim( Form_Alarme.TxtMinutos.Value ) , ;
            Form_Alarme.Release );
            Width   75                   ;
            Height  21

        @  48,128 Button BtCancela       ;
            Caption '&Cancel'            ;
            Action Form_Alarme.Release   ;
            Width   75                   ;
            Height  21

    End Window

    Form_Alarme.Activate

Return
/*
*/
Static Function MsgSobre()
        MsgInfo( PadC( "    " + PROGRAM +" "+ VERSION, 36 )   + CRLF + ;
        PadC(" Copyright " + Chr(169) + COPYRIGHT, 36)        + CRLF + ;
        PadC( "  "+AUTOR, 36 )                                + CRLF + ;
        PadC("hfornazier@yahoo.com.br", 36)                   + CRLF + CRLF + ;
        PadC("* This program is FreeWare *", 36)              + CRLF + CRLF + ;
        PadC("   Compiler and Libs", 36)                      + CRLF + CRLF + ;
        PadC(AllTrim(hb_compiler()),36)                       + CRLF + ;
        PadC(AllTrim(Version()) , 36 )                        + CRLF + ;
        PadC("https://harbour.github.io/", 36)                + CRLF + CRLF + ;
        Left(MiniGuiVersion(),36)                             + CRLF + ;
        PadC(" https://oohg.github.io/", 36)                  + CRLF + ;
        PadC(" Rewrited by MigSoft 2022 ", 36)                + CRLF + ;
        PadC("",36), "About MyPlayer" )
Return Nil
/*
*/
Procedure SkinsDisponiveis()
    Local aFiles := Directory( cDirExe+"Skins\*.Gif" )
    Local aItens := {}
    Local nRow   := oWin:Height() + oWin:Row()
    Local nCol   := iif( oWin:Col() - 105 >= 0, oWin:Col() - 105, oWin:Col() + oWin:Width() )

    For i := 1 To Len( aFiles )
        Aadd( aItens , Alltrim( aFiles[ i ][ 1 ] ) )
    Next

    If Len( aItens ) == 0
        MsgInfo("No Skins Available!!")
        Return Nil
    EnDif

    ASort( aItens )

    Define Window Form_Skins              ;
        At oWin:Row(),nCol                ; //100,88
        Width  105                        ;
        Height 300                        ;
        Title  'Skins...'                 ;
        ICON "MUSICAS2"                   ;
        MODAL                             ;
        NOSIZE

        @ 246,0 Image BackGr              ;
            PICTURE cSkin                 ;
            WIDTH 285 HEIGHT 80

        @ 0,0 LISTBOX List_1                ;
            WIDTH 100                       ;
            HEIGHT 245                      ;
            ITEMS aItens                    ;
            VALUE 1                         ;
            FONT "Ms Sans Serif" SIZE 09    ;
            ON CHANGE PreviewSkin( aItens[ Form_Skins.List_1.Value ] )

        @ 250,05 Button Bt_Close          ;
            Picture 'Close'                 ;
            Action Form_Skins.Release       ;
            Width   22                      ;
            Height  22 Flat ToolTip "Close"

    End Window

    Form_Skins.Activate

Return
/*
*/
Procedure PreviewSkin( xSkin )
    cSkin := cDirExe+"Skins\"+xSkin
    Form_Player.ImageBackGr.Picture := cSkin
Return
/*
*/
Procedure Config()
    Local cValue := ""
    Local nRow    := oWin:Height() + oWin:Row()
    Local nCol    := oWin:Col()

    BEGIN INI FILE cDirExe+"MyPlayer.ini"
        GET cValue SECTION "PREFERENCES" ENTRY "Songs That Contain the Word"
    END INI

    Define Window Form_Config               ;
        At nRow,nCol                        ;  // 260,192
        Width  491                          ;
        Height 153                          ;
        Title  'Player - Config'            ;
        Icon "Musicas2"                     ;
        Modal                               ;
        NoSize                              ;
        Font   'MS Sans Serif' Size 8

        @ 0,0 Image ImageBackGr             ;
            PICTURE cSkin                   ;
            WIDTH 486 HEIGHT 131

        @   3,  3 Frame GroupBox1               ;
            Caption ' Preferences '             ;
            Width  190                          ;
            Height  89                          ;
            FontColor WHITE BackColor BLACK

        @  25, 16 CheckBox Reproduzir           ;
            Caption 'Play Continuously'         ;
            Width  148                          ;
            Height  17                          ;
            FontColor BLACK

        @  42, 16 CheckBox Sortear              ;
            Caption 'Raffle Songs '             ;
            Width  148                          ;
            Height  17                          ;
            FontColor BLACK

        @   3,196 Frame GroupBox2                     ;
            Caption ' Select Songs With These Words ' ;
            Width  283                                ;
            Height  89                                ;
            FontColor WHITE BackColor BLACK

        @  16,203 EditBox Palavras              ;
            Value cValue                        ;
            Width  266                          ;
            Height  71

        @  96,197 Button Bt_Salvar              ;
            Caption '&Save Config'              ;
            Action Bt_Salvar_Execute()          ;
            Width  131                          ;
            Height  25 Flat                     ;
            ToolTip "Save - Attention: Words must be separated by semicolons ';' "

        @  96,348 Button Bt_Cancela             ;
            Caption '&Cancel'                   ;
            Action Form_Config.Release          ;
            Width  131                          ;
            Height  25 Flat

    End Window

    Form_Config.Reproduzir.Value := lContinua
    Form_Config.Sortear.Value    := lSorteia

    Form_Config.Activate
Return

